
Button = Core.class(Sprite)

function Button:init(text,x,y,scale)
	self.upState = Bitmap.new(Texture.new("button_up.png"))
	self.downState = Bitmap.new(Texture.new("button_down.png"))
	
	self:setPosition(x,y)
	self:setScale(scale,scale)
	--fonts and lables
	local font = TTFont.new("arial.ttf", 20)				-- this is TTFont without caching
	--FONT FOR CHANGE
	
	
	label = TextField.new(font, text)
	label:setTextColor(0xff6090)
	LHeight = label:getHeight()
	LWidth = label:getWidth()
	BHeight = self.upState:getHeight(self.upState)
	BWidth = self.upState:getWidth(self.upState)
	label:setPosition(x + (((BWidth * scale) / 2) - (LWidth / 2)),y + (((BHeight * scale) / 2) + (LHeight / 2)))
	--label:setPosition(x + (((self.upState:getWidth(self.upState) * scale) / 2)) - (label:getWidth() / 2) , y + (self.upState:getHeight(self.upState) * scale) - (label:getHeight() / 2))
	--label:setPosition(x + (((self.upState:getWidth(self.upState) * scale) / 2)) - (label:getWidth() / 2) , x + (self.upState:getHeight(self.upState) * scale) / 2 - ((label:getheight()) / 2))
	print(label:getHeight())
	
	self.focus = false
	self:updateVisualState(false)
	self:addEventListener(Event.MOUSE_DOWN, self.onMouseDown, self)
	self:addEventListener(Event.MOUSE_MOVE, self.onMouseMove, self)
	self:addEventListener(Event.MOUSE_UP, self.onMouseUp, self)

	self:addEventListener(Event.TOUCHES_BEGIN, self.onTouchesBegin, self)
	self:addEventListener(Event.TOUCHES_MOVE, self.onTouchesMove, self)
	self:addEventListener(Event.TOUCHES_END, self.onTouchesEnd, self)
	self:addEventListener(Event.TOUCHES_CANCEL, self.onTouchesCancel, self)
	stage:addChild(self)
	stage:addChild(label)
end

function Button:text(text)
	label:setText(text)
	x = self:getX()
	y = self:getY()
	LHeight = label:getHeight()
	LWidth = label:getWidth()
	BHeight = self.upState:getHeight(self.upState)
	BWidth = self.upState:getWidth(self.upState)
	
	label:setPosition(x + (((BWidth * self:getScale()) / 2) - (LWidth / 2)),y + (((BHeight * self:getScale()) / 2) + (LHeight / 2)))
	
end
function Button:onMouseDown(event)
	if self:hitTestPoint(event.x, event.y) then
		self.focus = true
		self:updateVisualState(true)
		event:stopPropagation()
	end
end

function Button:onMouseMove(event)
	if self.focus then
		if not self:hitTestPoint(event.x, event.y) then	
			self.focus = false
			self:updateVisualState(false)
		end
		event:stopPropagation()
	end
end

function Button:onMouseUp(event)
	if self.focus then
		self.focus = false
		self:updateVisualState(false)
		self:dispatchEvent(Event.new("click"))	-- button is clicked, dispatch "click" event
		event:stopPropagation()
	end
end

-- if button is on focus, stop propagation of touch events
function Button:onTouchesBegin(event)
	if self.focus then
		event:stopPropagation()
	end
end

-- if button is on focus, stop propagation of touch events
function Button:onTouchesMove(event)
	if self.focus then
		event:stopPropagation()
	end
end

-- if button is on focus, stop propagation of touch events
function Button:onTouchesEnd(event)
	if self.focus then
		event:stopPropagation()
	end
end

-- if touches are cancelled, reset the state of the button
function Button:onTouchesCancel(event)
	if self.focus then
		self.focus = false;
		self:updateVisualState(false)
		event:stopPropagation()
	end
end

-- if state is true show downState else show upState
function Button:updateVisualState(state)
	if state then
		if self:contains(self.upState) then
			self:removeChild(self.upState)
		end
		
		if not self:contains(self.downState) then
			self:addChild(self.downState)
		end
	else
		if self:contains(self.downState) then
			self:removeChild(self.downState)
		end
		
		if not self:contains(self.upState) then
			self:addChild(self.upState)
		end
	end
end
